#include "StdAfx.h"
#include ".\windowadapterscriptletplugin.h"
#include "ScriptletConstant.h"
#include "NWindowAdapter.h"
#include "XMLUtil.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_WIN32_NODE, CWindowAdapterScriptletPlugin);
CWindowAdapterScriptletPlugin::CWindowAdapterScriptletPlugin(void)
{
}

CWindowAdapterScriptletPlugin::~CWindowAdapterScriptletPlugin(void)
{
}
BOOL CWindowAdapterScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	CNWindowAdapter* pWin32Control = reinterpret_cast<CNWindowAdapter*>(pTarget);
	if (pWin32Control == NULL)
	{
		return FALSE;
	}
	TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
	TCHAR szHugeValue[SCRIPTLET_MAX_HUGE_VALUE] = {0};
	long lValue = 0;

	USES_CONVERSION;
	TCHAR szClassName[SCRIPTLET_MAX_VALUE] = {0};
	DWORD dwStyle = WS_CHILD;
	DWORD dwExStyle = 0;
	int nCtrlID = 0;

	//WC_LISTVIEW
	//wclass
	if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_WCLASS_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
		XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_WCLASS_NODE), szValue, SCRIPTLET_MAX_VALUE))
	{
		this->_ParseWindowClass(szValue);
		_tcsncpy_s(szClassName, szValue, SCRIPTLET_MAX_VALUE);
	}		
	//wsstyle
	if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_WSTYLE_NODE), szHugeValue, SCRIPTLET_MAX_HUGE_VALUE) ||
		XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_WSTYLE_NODE), szHugeValue, SCRIPTLET_MAX_HUGE_VALUE))
	{
		dwStyle |= ParseWindowStyle(szHugeValue);				
	}
	//wexstyle
	if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_WEXSTYLE_NODE), szHugeValue, SCRIPTLET_MAX_HUGE_VALUE) ||
		XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_WEXSTYLE_NODE), szHugeValue, SCRIPTLET_MAX_HUGE_VALUE))
	{
		dwExStyle = ParseWindowExStyle(szHugeValue);				
	}
	//ctrlid
	if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_CTRLID_NODE), lValue) ||
		XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_CTRLID_NODE), lValue))
	{
		nCtrlID = lValue;
	}
	HWND hWndParent = pParent->GetOwnerWindow();
	if (IsWindow(hWndParent))
	{
		pWin32Control->CreateExWindow(szClassName, dwStyle, hWndParent, nCtrlID, dwExStyle);				
	}	
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	return bSuccess;
}
CComponent* CWindowAdapterScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CNWindowAdapter;
	return pComponent;
}
DWORD CWindowAdapterScriptletPlugin::ParseWindowStyle(LPCTSTR pszcValue)
{
	DWORD dwStyle = 0;
	
	CString strValue = pszcValue;
	int nStart = 0;
	CString resToken = strValue.Tokenize(_T("|"), nStart);
	while (resToken != "")
	{
		resToken.Trim();
		dwStyle |= _ParseWindowStyle(resToken);
		resToken = strValue.Tokenize(_T("|"), nStart);
	}
	return dwStyle;
}
DWORD CWindowAdapterScriptletPlugin::ParseWindowExStyle(LPCTSTR pszcValue)
{
	DWORD dwExStyle = 0;
	CString strValue = pszcValue;
	int nStart = 0;
	CString resToken = strValue.Tokenize(_T("|"), nStart);
	while (resToken != "")
	{
		resToken.Trim();
		dwExStyle |= _ParseWindowExStyle(resToken);
		resToken = strValue.Tokenize(_T("|"), nStart);
	}
	return dwExStyle;
}
DWORD CWindowAdapterScriptletPlugin::_ParseWindowStyle(LPCTSTR pszcValue)
{
	static struct stStyle 
	{
		DWORD dwStyle;
		TCHAR szStyle[32];
	} STYLELIST[] = {
		{WS_OVERLAPPED, _T("WS_OVERLAPPED")},
		{WS_POPUP, _T("WS_POPUP")},
		{WS_CHILD, _T("WS_CHILD")},
		{WS_MINIMIZE, _T("WS_MINIMIZE")},
		{WS_VISIBLE, _T("WS_VISIBLE")},
		{WS_DISABLED, _T("WS_DISABLED")},
		{WS_CLIPSIBLINGS, _T("WS_CLIPSIBLINGS")},
		{WS_CLIPCHILDREN, _T("WS_CLIPCHILDREN")},
		{WS_CAPTION, _T("WS_CAPTION")},
		{WS_BORDER, _T("WS_BORDER")},
		{WS_DLGFRAME, _T("WS_DLGFRAME")},
		{WS_VSCROLL, _T("WS_VSCROLL")},
		{WS_HSCROLL, _T("WS_HSCROLL")},
		{WS_SYSMENU, _T("WS_SYSMENU")},
		{WS_THICKFRAME, _T("WS_THICKFRAME")},
		{WS_GROUP, _T("WS_GROUP")},
		{WS_MINIMIZEBOX, _T("WS_MINIMIZEBOX")},
		{WS_MAXIMIZEBOX, _T("WS_MAXIMIZEBOX")},
		{WS_TILED, _T("WS_TILED")},
		{WS_ICONIC, _T("WS_ICONIC")},
		{WS_SIZEBOX, _T("WS_SIZEBOX")},
		{WS_TILEDWINDOW, _T("WS_TILEDWINDOW")},
		{WS_OVERLAPPEDWINDOW, _T("WS_OVERLAPPEDWINDOW")},
		{WS_POPUPWINDOW, _T("WS_POPUPWINDOW")},
		{WS_CHILDWINDOW, _T("WS_CHILDWINDOW")},
		{DS_MODALFRAME, _T("DS_MODALFRAME")},
		{DS_3DLOOK, _T("DS_3DLOOK")},
		// PM-535 2007/10/09 18:17:10 
		// PM-574 2007/10/09 18:19:17 
		// PM-580 2007/10/09 18:20:30 
		{WS_TABSTOP, _T("WS_TABSTOP")},
		{CBS_SIMPLE , _T("CBS_SIMPLE ")},
		{CBS_DROPDOWN, _T("CBS_DROPDOWN")},
		{CBS_DROPDOWNLIST, _T("CBS_DROPDOWNLIST")},
		{CBS_OWNERDRAWFIXED, _T("CBS_OWNERDRAWFIXED")},
		{CBS_OWNERDRAWVARIABLE, _T("CBS_OWNERDRAWVARIABLE")},
		{CBS_AUTOHSCROLL, _T("CBS_AUTOHSCROLL")},
		{CBS_OEMCONVERT, _T("CBS_OEMCONVERT")},
		{CBS_SORT, _T("CBS_SORT")},
		{CBS_HASSTRINGS, _T("CBS_HASSTRINGS")},
		{CBS_NOINTEGRALHEIGHT, _T("CBS_NOINTEGRALHEIGHT")},
		{CBS_DISABLENOSCROLL, _T("CBS_DISABLENOSCROLL")},
		{CBS_UPPERCASE, _T("CBS_UPPERCASE")},
		{CBS_LOWERCASE, _T("CBS_LOWERCASE")},
		{ES_LEFT, _T("ES_LEFT")},
		{ES_CENTER, _T("ES_CENTER")},
		{ES_RIGHT, _T("ES_RIGHT")},
		{ES_MULTILINE, _T("ES_MULTILINE")},
		{ES_UPPERCASE, _T("ES_UPPERCASE")},
		{ES_LOWERCASE, _T("ES_LOWERCASE")},
		{ES_PASSWORD, _T("ES_PASSWORD")},
		{ES_AUTOVSCROLL, _T("ES_AUTOVSCROLL")},
		{ES_AUTOHSCROLL, _T("ES_AUTOHSCROLL")},
		{ES_NOHIDESEL, _T("ES_NOHIDESEL")},
		{ES_OEMCONVERT, _T("ES_OEMCONVERT")},
		{ES_READONLY, _T("ES_READONLY")},
		{ES_WANTRETURN, _T("ES_WANTRETURN")},
		{ES_NUMBER, _T("ES_NUMBER")},
		{BS_3STATE, _T("BS_3STATE")},
		{BS_AUTO3STATE, _T("BS_AUTO3STATE")},
		{BS_AUTOCHECKBOX, _T("BS_AUTOCHECKBOX")},
		{BS_AUTORADIOBUTTON, _T("BS_AUTORADIOBUTTON")},
		{BS_CHECKBOX, _T("BS_CHECKBOX")},
		{BS_DEFPUSHBUTTON, _T("BS_DEFPUSHBUTTON")},
		{BS_GROUPBOX, _T("BS_GROUPBOX")},
		{BS_LEFTTEXT, _T("BS_LEFTTEXT")},
		{BS_OWNERDRAW, _T("BS_OWNERDRAW")},
		{BS_PUSHBUTTON, _T("BS_PUSHBUTTON")},
		{BS_RADIOBUTTON, _T("BS_RADIOBUTTON")},
		{BS_USERBUTTON, _T("BS_USERBUTTON")},
		{BS_BITMAP, _T("BS_BITMAP")},
		{BS_BOTTOM, _T("BS_BOTTOM")},
		{BS_CENTER, _T("BS_CENTER")},
		{BS_ICON, _T("BS_ICON")},
		{BS_FLAT, _T("BS_FLAT")},
		{BS_LEFT, _T("BS_LEFT")},
		{BS_MULTILINE, _T("BS_MULTILINE")},
		{BS_NOTIFY, _T("BS_NOTIFY")},
		{BS_PUSHLIKE, _T("BS_PUSHLIKE")},
		{BS_RIGHT, _T("BS_RIGHT")},
		{BS_RIGHTBUTTON, _T("BS_RIGHTBUTTON")},
		{BS_TEXT, _T("BS_TEXT")},
		{BS_TOP, _T("BS_TOP")},
		{BS_TYPEMASK, _T("BS_TYPEMASK")},
		{BS_VCENTER, _T("BS_VCENTER")},
		{LBS_COMBOBOX, _T("LBS_COMBOBOX")},
		{LBS_DISABLENOSCROLL, _T("LBS_DISABLENOSCROLL")},
		{LBS_EXTENDEDSEL, _T("LBS_EXTENDEDSEL")},
		{LBS_HASSTRINGS, _T("LBS_HASSTRINGS")},
		{LBS_MULTICOLUMN, _T("LBS_MULTICOLUMN")},
		{LBS_MULTIPLESEL, _T("LBS_MULTIPLESEL")},
		{LBS_NODATA, _T("LBS_NODATA")},
		{LBS_NOINTEGRALHEIGHT, _T("LBS_NOINTEGRALHEIGHT")},
		{LBS_NOREDRAW, _T("LBS_NOREDRAW")},
		{LBS_NOSEL, _T("LBS_NOSEL")},
		{LBS_NOTIFY, _T("LBS_NOTIFY")},
		{LBS_OWNERDRAWFIXED, _T("LBS_OWNERDRAWFIXED")},
		{LBS_OWNERDRAWVARIABLE, _T("LBS_OWNERDRAWVARIABLE")},
		{LBS_SORT, _T("LBS_SORT")},
		{LBS_STANDARD, _T("LBS_STANDARD")},
		{LBS_USETABSTOPS, _T("LBS_USETABSTOPS")},
		{LBS_WANTKEYBOARDINPUT, _T("LBS_WANTKEYBOARDINPUT")},
		{LVS_ALIGNLEFT, _T("LVS_ALIGNLEFT")},
		{LVS_ALIGNMASK, _T("LVS_ALIGNMASK")},
		{LVS_ALIGNTOP, _T("LVS_ALIGNTOP")},
		{LVS_AUTOARRANGE, _T("LVS_AUTOARRANGE")},
		{LVS_EDITLABELS, _T("LVS_EDITLABELS")},
		{LVS_ICON, _T("LVS_ICON")},
		{LVS_LIST, _T("LVS_LIST")},
		{LVS_NOCOLUMNHEADER, _T("LVS_NOCOLUMNHEADER")},
		{LVS_NOLABELWRAP, _T("LVS_NOLABELWRAP")},
		{LVS_NOSCROLL, _T("LVS_NOSCROLL")},
		{LVS_NOSORTHEADER, _T("LVS_NOSORTHEADER")},
		{LVS_OWNERDATA, _T("LVS_OWNERDATA")},
		{LVS_OWNERDRAWFIXED, _T("LVS_OWNERDRAWFIXED")},
		{LVS_REPORT, _T("LVS_REPORT")},
		{LVS_SHAREIMAGELISTS, _T("LVS_SHAREIMAGELISTS")},
		{LVS_SHOWSELALWAYS, _T("LVS_SHOWSELALWAYS")},
		{LVS_SINGLESEL, _T("LVS_SINGLESEL")},
		{LVS_SMALLICON, _T("LVS_SMALLICON")},
		{LVS_SORTASCENDING, _T("LVS_SORTASCENDING")},
		{LVS_SORTDESCENDING, _T("LVS_SORTDESCENDING")},
		{LVS_TYPEMASK, _T("LVS_TYPEMASK")},
		{LVS_TYPESTYLEMASK, _T("LVS_TYPESTYLEMASK")},
	};
	static int s_nCount = sizeof(STYLELIST)/sizeof(STYLELIST[0]);
	DWORD dwStyle = 0;
	for (int i=0; i<s_nCount; i++)
	{
		if (_tcsicmp(pszcValue, STYLELIST[i].szStyle) == 0)
		{
			dwStyle = STYLELIST[i].dwStyle;
			break;
		}
	}
	return dwStyle;
}
DWORD CWindowAdapterScriptletPlugin::_ParseWindowExStyle(LPCTSTR pszcValue)
{
	static struct stExStyle 
	{
		DWORD dwExStyle;
		TCHAR szExStyle[32];
	}STYLEEXLIST[] = {
		{WS_EX_DLGMODALFRAME, _T("WS_EX_DLGMODALFRAME")},
		{WS_EX_NOPARENTNOTIFY, _T("WS_EX_NOPARENTNOTIFY")},
		{WS_EX_TOPMOST, _T("WS_EX_TOPMOST")},
		{WS_EX_ACCEPTFILES, _T("WS_EX_ACCEPTFILES")},
		{WS_EX_TRANSPARENT, _T("WS_EX_TRANSPARENT")},
		{WS_EX_MDICHILD, _T("WS_EX_MDICHILD")},
		{WS_EX_TOOLWINDOW, _T("WS_EX_TOOLWINDOW")},
		{WS_EX_WINDOWEDGE, _T("WS_EX_WINDOWEDGE")},
		{WS_EX_CLIENTEDGE, _T("WS_EX_CLIENTEDGE")},
		{WS_EX_CONTEXTHELP, _T("WS_EX_CONTEXTHELP")},
		{WS_EX_RIGHT, _T("WS_EX_RIGHT")},
		{WS_EX_LEFT, _T("WS_EX_LEFT")},
		{WS_EX_RTLREADING, _T("WS_EX_RTLREADING")},
		{WS_EX_LTRREADING, _T("WS_EX_LTRREADING")},
		{WS_EX_LEFTSCROLLBAR, _T("WS_EX_LEFTSCROLLBAR")},
		{WS_EX_RIGHTSCROLLBAR, _T("WS_EX_RIGHTSCROLLBAR")},
		{WS_EX_CONTROLPARENT, _T("WS_EX_CONTROLPARENT")},
		{WS_EX_STATICEDGE, _T("WS_EX_STATICEDGE")},
		{WS_EX_APPWINDOW, _T("WS_EX_APPWINDOW")},
		{WS_EX_OVERLAPPEDWINDOW, _T("WS_EX_OVERLAPPEDWINDOW")},
		{WS_EX_PALETTEWINDOW, _T("WS_EX_PALETTEWINDOW")},
		{WS_EX_LAYERED, _T("WS_EX_LAYERED")},
		{WS_EX_NOINHERITLAYOUT, _T("WS_EX_NOINHERITLAYOUT")},
		{WS_EX_LAYOUTRTL, _T("WS_EX_LAYOUTRTL")},
		{WS_EX_COMPOSITED, _T("WS_EX_COMPOSITED")},
		{WS_EX_NOACTIVATE, _T("WS_EX_NOACTIVATE")},
		//{LVS_EX_ALTERNATEROWCOLOR, _T("LVS_EX_ALTERNATEROWCOLOR")},
		//{LVS_EX_AUTOAUTOARRANGE, _T("LVS_EX_AUTOAUTOARRANGE")},
		//{LVS_EX_AUTOCHECKSELECT, _T("LVS_EX_AUTOCHECKSELECT")},
		//{LVS_EX_AUTOSIZECOLUMNS, _T("LVS_EX_AUTOSIZECOLUMNS")},
		{LVS_EX_BORDERSELECT, _T("LVS_EX_BORDERSELECT")},
		{LVS_EX_CHECKBOXES, _T("LVS_EX_CHECKBOXES")},
		//{LVS_EX_COLUMNSNAPPOINTS, _T("LVS_EX_COLUMNSNAPPOINTS")},
		{LVS_EX_DOUBLEBUFFER, _T("LVS_EX_DOUBLEBUFFER")},
		{LVS_EX_FLATSB, _T("LVS_EX_FLATSB")},
		{LVS_EX_FLATSB, _T("LVS_EX_FLATSB")},
		{LVS_EX_FULLROWSELECT, _T("LVS_EX_FULLROWSELECT")},
		{LVS_EX_FULLROWSELECT, _T("LVS_EX_FULLROWSELECT")},
		{LVS_EX_GRIDLINES, _T("LVS_EX_GRIDLINES")},
		{LVS_EX_HEADERDRAGDROP, _T("LVS_EX_HEADERDRAGDROP")},
		//{LVS_EX_HEADERINALLVIEWS, _T("LVS_EX_HEADERINALLVIEWS")},
		{LVS_EX_INFOTIP, _T("LVS_EX_INFOTIP")},
		//{LVS_EX_JUSTIFYCOLUMNS, _T("LVS_EX_JUSTIFYCOLUMNS")},
		{LVS_EX_LABELTIP, _T("LVS_EX_LABELTIP")},
		{LVS_EX_MULTIWORKAREAS, _T("LVS_EX_MULTIWORKAREAS")},
		{LVS_EX_ONECLICKACTIVATE, _T("LVS_EX_ONECLICKACTIVATE")},
		{LVS_EX_REGIONAL, _T("LVS_EX_REGIONAL")},
		{LVS_EX_SIMPLESELECT, _T("LVS_EX_SIMPLESELECT")},
		{LVS_EX_SUBITEMIMAGES, _T("LVS_EX_SUBITEMIMAGES")},
		{LVS_EX_TRACKSELECT, _T("LVS_EX_TRACKSELECT")},
		//{LVS_EX_TRANSPARENTBKGND, _T("LVS_EX_TRANSPARENTBKGND")},
		//{LVS_EX_TRANSPARENTSHADOWTEXT, _T("LVS_EX_TRANSPARENTSHADOWTEXT")},
		{LVS_EX_TWOCLICKACTIVATE, _T("LVS_EX_TWOCLICKACTIVATE")},
		{LVS_EX_UNDERLINECOLD, _T("LVS_EX_UNDERLINECOLD")},
		{LVS_EX_UNDERLINEHOT, _T("LVS_EX_UNDERLINEHOT")},
	};
	static int s_nCount = sizeof(STYLEEXLIST)/sizeof(STYLEEXLIST[0]);
	DWORD dwExStyle = 0;
	for (int i=0; i<s_nCount; i++)
	{
		if (_tcsicmp(pszcValue, STYLEEXLIST[i].szExStyle) == 0)
		{
			dwExStyle = STYLEEXLIST[i].dwExStyle;
			break;
		}
	}
	return dwExStyle;
}

void CWindowAdapterScriptletPlugin::_ParseWindowClass( LPTSTR pszcValue )
{
	if (_tcscmp(pszcValue, _T("WC_LISTVIEW")) == 0)
	{
		_tcscpy(pszcValue, WC_LISTVIEW);
	}
}